<template>
  <ob-form
    class="contract-direction-form"
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isDraft"
    data-qa="directionForm"
    @submit="onSubmitHandler"
    :ok-text="isNew ? 'Добавить' : 'Сохранить'"
    cancel-text="Отменить"
  >
    <p class="mb30">
      <template v-if="service.resourceSpeciesTitle">
        {{ service.serviceTypeTitle }}.<br>
        {{ service.resourceSpeciesTitle }}. {{service.resourceSubtypeTitle}}.
        {{ service.resourcePatternParameter }}. {{ service.serviceUnitTitle }}.
      </template>
      <template v-else>
        {{ service.serviceTypeTitle }}. {{ service.serviceUnitTitle }}.
      </template>
    </p>
    <template v-if="isNew">
      <ObSelect
        v-model="formData.locationFromUuid"
        label="Откуда"
        placeholder="Укажите начальную точку маршрута"
        :remote-opt="api.contract.getLocations"
        :initial-value="initialValue(formData.locationFromUuid)"
        :is-search="true"
        display-exp="russian_name"
        class="mb20"
        data-qa="locationFrom"
        @selected="onSelectLocation"
      />
      <ObSelect
        v-model="formData.locationToUuid"
        label="Куда"
        placeholder="Укажите конечную точку маршрута"
        :remote-opt="api.contract.getLocations"
        :is-search="true"
        :initial-value="initialValue(formData.locationToUuid)"
        display-exp="russian_name"
        class="mb30"
        data-qa="locationTo"
        @selected="onSelectLocation"
      />
    </template>
    <template v-if="formData.transboundary">
      <div class="nds-row mb30 mt20">
        <i class="icon alert" />
        <span v-if="formData.vatType !== 'NO_VAT'">{{ service.isVatInclude ? 'Все тарифы включают в себя НДС' : 'Тарифы указываются без учета НДС' }} {{ formData.vatRate }}%</span>
        <span v-else>Не облагается НДС</span>
      </div>
      <div class="row mb15">
        <div class="col-xs-6">
          <div class="sub-title">Тариф перевозки в один конец:</div>
          <div class="row">
            <div class="col-xs-6">
              <ObInput
                :value="getTariff('tariff')"
                label="Тариф в один конец"
                sub-title="₽"
                placeholder="56 000"
                type="money:2"
                :readonly="!isDraft"
                data-qa="tariff"
                @input="onInputTariff('tariff', $event)"
              />
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-xs-6">
          <div class="sub-title">Тариф допробега (необязательно):</div>
          <div class="row">
            <div class="col-xs-6">
              <ObInput
                :value="getTariff('extraMileageTariff')"
                label="Тариф допробега"
                sub-title="₽/км"
                placeholder="Укажите"
                type="money:2"
                :readonly="!isDraft"
                data-qa="extraMileageTariff"
                @input="onInputTariff('extraMileageTariff', $event)"
              />
            </div>
          </div>
        </div>
        <div class="col-xs-6">
          <div class="sub-title">Тариф за допточку (необязательно):</div>
          <div class="row">
            <div class="col-xs-6">
              <ObInput
                :value="getTariff('extraPointTariff')"
                label="Тариф за допточку"
                sub-title="₽"
                placeholder="Укажите"
                type="money:2"
                :readonly="!isDraft"
                data-qa="extraPointTariff"
                @input="onInputTariff('extraPointTariff', $event)"
              />
            </div>
          </div>
        </div>
      </div>
    </template>
  </ob-form>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import models from '@/models'
  import cloneDeep from 'clone-deep'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import debounce from "debounce";

  export default {
    name: 'ContractDirectionForm',
    components: {
      ObSelect,
      ObInput,
      ObForm
    },
    mixins: [
      FormValidationMixin
    ],
    props: {
      service: {
        type: Object,
        default: () => {}
      }
    },
    data () {
      return {
        api,
        dropdownMenu: [
          {
            label: 'Отключить направление',
            method: this.disableDirection
          }
        ],
        locationsData: {}
      }
    },
    computed: {
      ...mapGetters({
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      formModel () {
        const { vatType = 'NO_VAT', vatRate = 0 } = this.dataSource || {}

        if (this.isNew) {
          return models.contract.directions({ isVatPayer: this.isVatPayer })
        } else {
          return models.contract.directionsEdit({
            isVatPayer: this.isVatPayer,
            vatType,
            vatRate
          })
        }
      },
      isNew () {
        return !this.dataSource?.directionUuid
      }
    },
    methods: {
      async afterInitForm () {
        const { locationFromUuid, locationToUuid } = this.dataSource || {}

        if ((locationFromUuid && !locationToUuid) || (!locationFromUuid && locationToUuid)) {
          await this.getLocationInfo({ uuid: locationFromUuid || locationToUuid })
        }
      },
      async getLocationInfo ({ uuid }) {
        const res = await api.contract.getDictionaryLocationDetail({ uuid })
        this.$set(this.locationsData, uuid, res)
      },
      initialValue (uuid) {
        return this.locationsData[uuid] ? [ { ...this.locationsData[uuid] } ] : []
      },
      onSubmitHandler () {
        let data = cloneDeep(this.formData);

        this.$emit('submit', {formData: data, model: this.formModel})
      },
      onSelectLocation (data = {}) {
        this.locationsData[data.uuid] = data
        this.$nextTick(async () => {
          if (this.formData.locationFromUuid && this.formData.locationToUuid) {
            await this.getRouteParams()
          }
        })
      },
      async getRouteParams () {
        let points = [this.formData.locationFromUuid, this.formData.locationToUuid].map((uuid) => {
          return { ...this.locationsData[uuid].coordinates }
        })

        let { transboundary, routeCategory } = await api.contract.getRouteParams({ points })

        this.formData.transboundary = transboundary
        this.formData.routeCategory = routeCategory

        if (transboundary === 'DOMESTIC' && routeCategory !== 'INTERNATIONAL' && this.isVatPayer) {
          this.formData.vatType = 'TWENTY'
          this.formData.vatRate = 20
        } else if (transboundary === 'CROSSBOARDING' && routeCategory === 'INTERNATIONAL' && this.isVatPayer) {
          this.formData.vatType = 'ZERO'
          this.formData.vatRate = 0
        } else {
          this.formData.vatType = 'NO_VAT'
          this.formData.vatRate = 0
        }

        this.$nextTick(async () => {
          await this.calcTariff()
        })
      },
      disableDirection () {
        this.$emit('on-disable-direction', { uuid: this.formData.directionUuid })
      },
      async onInputTariff (key, value) {
        this.formData[key][this.service.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] = value
        await this.calcTariff()
      },
      calcTariff: debounce(async function() {
        let targetKeys = [ 'tariff', 'extraMileageTariff', 'extraPointTariff' ].filter(targetKey => {
          return this.formData[targetKey]?.[this.service.isVatInclude ? 'priceWithVat' : 'priceWithoutVat'] !== undefined
        })

        let postData = targetKeys.map(targetKey => {
          const priceObject = this.service.isVatInclude
            ? { priceWithVat: this.formData[targetKey]?.priceWithVat || '' }
            : { priceWithoutVat: this.formData[targetKey]?.priceWithoutVat || '' }
          return {
            vatRate: this.formData.vatRate,
            quantity: 1,
            ...priceObject
          }
        })

        if (this.formData.vatType !== 'NO_VAT') {
          let { itemsList } = await api.orderProcess.vatCalculation({ list: postData })

          targetKeys.forEach((targetKey, index) => {
            const { priceWithVat = '', priceWithoutVat = '', vatValue = '' } = itemsList[index] || {}
            this.formData[targetKey].priceWithVat = priceWithVat
            this.formData[targetKey].priceWithoutVat = priceWithoutVat
            this.formData[targetKey].vatPrice = vatValue
          })
        } else {
          targetKeys.forEach(targetKey => {
            this.formData[targetKey].priceWithVat = this.formData[targetKey]?.priceWithoutVat
            this.formData[targetKey].vatPrice = 0
          })
        }
      }, 500),
      getTariff (key) {
        return this.service.isVatInclude ? this.formData[key]?.priceWithVat : this.formData[key]?.priceWithoutVat
      }
    }
  }
</script>

<style lang='scss' scoped>
  @import '~common-components/src/static/css/mixins';

  .contract-direction-form {
    .main-title {
      @include font-mixin(20px, 28px, 600, $color-text-base, 0.4px);
    }

    .sub-title {
      margin-bottom: 10px;
      @include font-mixin(16px, 24px, 600, $color-text-base, 0.4px);
    }

    .nds-row {
      width: 100%;
      display: flex;
      align-items: center;
      padding: 20px;
      background-color: $color-white-lilac;
      .icon {
        font-size: 24px;
        color: $color-blue-navy-blue;
      }
      span {
        padding-left: 20px;
        font-size: 14px;
        line-height: 20px;
        color: $color-text-base;
      }
    }
  }
</style>

<style lang="scss">
  .contract-direction-form {
    .mt20 {
      margin-top: 20px!important;
    }

    .mb20 {
      margin-bottom: 20px !important;
    }

    .mb15 {
      margin-bottom: 15px !important;
    }

    .mb30 {
      margin-bottom: 30px!important;
    }

    .checkbox-input {
      display: flex;
      justify-content: flex-start;
      align-items: center;

      .ob-checkbox-container {
        flex-shrink: 0;
        margin-left: 20px;
      }
    }
  }
</style>
